package index.alg;

import index.entity.Box;
import index.entity.Point;
import index.entity.WholeIndex;

import java.util.ArrayList;

public class BuildBoxFromList {

    Integer workNumber = 0;
    Integer occupyNumber = 1;
    Integer otherNumber = 3;


    //
    public ArrayList<Box> build(WholeIndex wholeIndex,ArrayList<ArrayList<Integer>> indexsList){

        Double minX = wholeIndex.getMinX();
        Double minY = wholeIndex.getMinY();
        Integer numOfGapsX = wholeIndex.getNumOfGapsX();
        Integer numOfGapsY = wholeIndex.getNumOfGapsY();
        Double xGap =wholeIndex.getxGap();
        Double yGap = wholeIndex.getyGap();

        ArrayList<Box> boxArrayList = new ArrayList<>();
        for (int i = 0 ; i < indexsList.size();i++){

            ArrayList<Integer> indexs = indexsList.get(i);
            for (int j = 0 ; j < indexs.size();j++){

                Integer symbolNumber = indexs.get(j);

                if (symbolNumber.equals(occupyNumber)){

                    Point leftUpPoint = new Point();
                    Point rightUpPoint = new Point();
                    Point rightDownPoint = new Point();
                    Point leftDownPoint = new Point();

//                    Double minXOfBox = i * xGap;
//                    Double maxXOfBox = minXOfBox + xGap;
//                    Double minYOfBox = j * yGap;
//                    Double maxYOfBox = minYOfBox + yGap;

                    double minXOfBox = i;
                    double maxXOfBox = i + 1 ;
                    double minYOfBox = j;
                    double maxYOfBox = j + 1;

                    //左上角的点
                    leftUpPoint.setColX(minXOfBox);
                    leftUpPoint.setColY(maxYOfBox);

                    //右上角的点
                    rightUpPoint.setColX(maxXOfBox);
                    rightUpPoint.setColY(maxYOfBox);

                    //右下角的点
                    rightDownPoint.setColX(maxXOfBox);
                    rightDownPoint.setColY(minYOfBox);

                    //左下角的点
                    leftDownPoint.setColX(minXOfBox);
                    leftDownPoint.setColY(minYOfBox);

                    ArrayList<Point> pointsList = new ArrayList<>();
                    pointsList.add(leftUpPoint);
                    pointsList.add(rightUpPoint);
                    pointsList.add(rightDownPoint);
                    pointsList.add(leftDownPoint);

                    Box box = new Box();
                    box.setPointsList(pointsList);
                    box.setPointSymbol(leftUpPoint);
                    box.buildBoxEdgeArrayList();
                    boxArrayList.add(box);
                }

            }

        }

        return boxArrayList;


    }

}
