package index.alg;

import index.entity.BeginEndPoint;
import index.entity.LineSegment;
import index.entity.Point;

import javax.swing.text.Segment;
import java.util.ArrayList;

public class BuildLines {

    public ArrayList<LineSegment> build(ArrayList<Point> pointsList){

        ArrayList<LineSegment> lineSegments = new ArrayList<>();
        CurveTool tool = new CurveTool();

        for (int i = 0 ; i < (pointsList.size() - 1);i++){

            //两个点形成直线
            Point pointI = pointsList.get(i);
            Point pointJ = pointsList.get(i + 1);
            boolean isTest = false;

            //直线一般式相关的参数，A,B,C
            ArrayList<Double> lineParamList  = tool.calLineabc(pointI,pointJ);
            BeginEndPoint beginEndPoint = new BeginEndPoint(pointI,pointJ);
            LineSegment lineSegment = new LineSegment();
            lineSegment.setBeginEndPoint(beginEndPoint);
            lineSegment.setLineParamList(lineParamList);
            lineSegments.add(lineSegment);

        }

        return lineSegments;

    }




}
