package index.alg;

import index.entity.*;

import java.util.ArrayList;

public  class OccupyTransfer {

    public static OccupyIndex pointToIndex(WholeIndex wholeIndex, OccupyPoint occupyPoint){

//         获取网格划分的一些参数
        Double minX = wholeIndex.getMinX();
        Double minY = wholeIndex.getMinY();
        Integer numOfGapsX = wholeIndex.getNumOfGapsX();
        Integer numOfGapsY = wholeIndex.getNumOfGapsY();
        Double xGap =wholeIndex.getxGap();
        Double yGap = wholeIndex.getyGap();

        IndexTool indexTool = new IndexTool(wholeIndex);

        //
        ArrayList<ArrayList<BeginEndPoint>> occupyPoints = occupyPoint.getOccupyPoints();

        //
        ArrayList<ArrayList<BeginEndIndex>> occupyIndexs = new ArrayList<>();



        for (int i = 0 ; i < occupyPoints.size();i++){

            //一列
            ArrayList<BeginEndPoint> thisOccupyPoint = occupyPoints.get(i);

            //
            ArrayList<BeginEndIndex> thisOccupyIndex = new ArrayList<>();

            for (int j = 0 ; j < thisOccupyPoint.size();j++){

                BeginEndPoint beginEndPoint = thisOccupyPoint.get(j);
                Point beginPoint = beginEndPoint.getBeginPoint();
                Point endPoint = beginEndPoint.getEndPoint();
                Index beginIndex = indexTool.identifyIndex(beginPoint);
                Index endIndex = indexTool.identifyIndex(endPoint);
                BeginEndIndex beginEndIndex = new BeginEndIndex();
                beginEndIndex.setBeginIndex(beginIndex);
                beginEndIndex.setEndIndex(endIndex);
                thisOccupyIndex.add(beginEndIndex);
            }

            occupyIndexs.add(thisOccupyIndex);


        }

        OccupyIndex occupyIndex = new OccupyIndex();
        occupyIndex.setOccupyIndexs(occupyIndexs);
        return occupyIndex;

    }

    public static void indexToPoint(){



    }

}
