package index.db;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class ConnectToSourceDB {
    String userName;
    String passwd;
    String driver;
    String url;//uat

    Connection connection = null;


    public void setConnPara(String userName,String passwd,String driver, String url){
        this.userName = userName;
        this.passwd = passwd;
        this.driver = driver;
        this.url = url;
    }


    public Connection getConnection() {

        try {
            Class.forName(driver);
            connection = (Connection) DriverManager.getConnection(url, userName, passwd);
        }catch(ClassNotFoundException e){
            throw new RuntimeException("class not find!",e);
        }catch (SQLException e){
            throw new RuntimeException("get connection error",e);
        }
        return connection;
    }



}
