package index.entity;

import java.util.ArrayList;

public class Box {

    //网格的四个点，point里面并非真实物理坐标，用格子标号，比如（0，1），（1，0），（0，0），（1，1）,new的时候要按照顺序
    ArrayList<Point> pointsList = new ArrayList<>();

    //网格的标志点，选取左上角的那个点
    Point pointSymbol;

    //网格的四条边
    ArrayList<BoxEdge> boxEdgeArrayList;

    //盒子宽度


    public ArrayList<Point> getPointsList() {
        return pointsList;
    }

    public void setPointsList(ArrayList<Point> pointsList) {
        this.pointsList = pointsList;
    }

    public Point getPointSymbol() {
        return pointSymbol;
    }

    public void setPointSymbol(Point pointSymbol) {
        this.pointSymbol = pointSymbol;
    }

    public ArrayList<BoxEdge> getBoxEdgeArrayList() {
        return boxEdgeArrayList;
    }

    public void setBoxEdgeArrayList(ArrayList<BoxEdge> boxEdgeArrayList) {
        this.boxEdgeArrayList = boxEdgeArrayList;
    }

    public void buildBoxEdgeArrayList(){

        ArrayList<BoxEdge> boxEdgeArrayList = new ArrayList<>();

        for (int i = 0 ; i < pointsList.size() - 1;i++){

            Point pointI = pointsList.get(i);
            Point pointJ = pointsList.get(i + 1);
            BoxEdge boxEdge = new BoxEdge();
            boxEdge.setPoint12(pointI,pointJ);
            boxEdgeArrayList.add(boxEdge);

        }

        BoxEdge boxEdgeLast = new BoxEdge();
        boxEdgeLast.setPoint12(pointsList.get(0),pointsList.get(pointsList.size() - 1));

        boxEdgeArrayList.add(boxEdgeLast);

        this.boxEdgeArrayList = boxEdgeArrayList;


    }
}
