package shift;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class CalculateArea {

    ArrayList<Double> Pointx_input = new ArrayList<>();

    ArrayList<Double> Pointy_input = new ArrayList<>();

    ArrayList<Double> Pointx_input_initial;

    ArrayList<Double> Pointy_input_initial;

    ArrayList<Double> Row_input = new ArrayList<>();

    ArrayList<Double> Theta_input = new ArrayList<>();

    ArrayList<Double> centerx_history;

    ArrayList<Double> centery_history;

    ArrayList<DataType<Double>> Result_Row = new ArrayList<>();

    ArrayList<DataType<Double>> Result_Theta = new ArrayList<>();

    double FinalCenterX;
    double FinalCenterY;
    double RusedforMeanShift;
    double SplitTheta;
    double SplitRadiusWidth;
    double IncreasingRate;
    double Area = 0.0 ;

    public CalculateArea(ArrayList<Double> Pointx_input,ArrayList<Double> Pointy_input,ArrayList<Double> centerx_history,ArrayList<Double> centery_history){
        this.Pointx_input_initial = Pointx_input;
        this.Pointy_input_initial = Pointy_input;
        this.centerx_history = centerx_history;
        this.centery_history = centery_history;
    }



    public void setRusedforMeanShift(double RusedforMeanShift){
        this.RusedforMeanShift = RusedforMeanShift;
    }

    public void setSplitTheta(double SplitTheta){
        this.SplitTheta = SplitTheta;
    }

    public void setSplitRadiusWidth(double SplitRadiusWidth){
        this.SplitRadiusWidth =  SplitRadiusWidth;
    }

    public void setIncreasingRate(double IncreasingRate){
        this.IncreasingRate = IncreasingRate;
    }

    public double CalculateTheta(Double x ,Double y ,Double row){
        double Theta = 0;
        if( y > 0 ){
            Theta = Math.acos(x/row);
        }
        else if( y < 0 ){
            Theta = 2 * Math.PI - Math.acos(x/row);
        }
        return Theta;
    }

    public Integer Compare(double R){

        double Max = 0 ;
        int IndexofMax = 0;
        for(int i = 0 ; i < centerx_history.size(); i++ ){
            System.out.println("findPointinsideR(centerx_history.get(i),centery_history.get(i),R): " + FindPointinsideR(centerx_history.get(i),centery_history.get(i),R));
            System.out.println("第 " + i + " 个历史圆");
            if(FindPointinsideR(centerx_history.get(i),centery_history.get(i),R) > Max){
                Max = FindPointinsideR(centerx_history.get(i),centery_history.get(i),R);
                IndexofMax = i;
            }
        }
        return IndexofMax;
    }

    public void configFinalCircle(){
        int IndexofMax;
        IndexofMax = Compare(RusedforMeanShift);
        System.out.println("IndexofMax" + IndexofMax);
        FinalCenterX = centerx_history.get(IndexofMax);
        FinalCenterY = centery_history.get(IndexofMax);
        System.out.println("FinalCenterX " + FinalCenterX);
        System.out.println("FinalCenterY " + FinalCenterY);
    }

    public double FindPointinsideR(double centerx,double centery,double R){
        ArrayList<Integer> NuminsideR = new ArrayList<>();
        for(int i = 0 ; i < Pointx_input_initial.size() ; i++){
            if (CalculateDistance(Pointx_input_initial.get(i),Pointy_input_initial.get(i),centerx,centery) < R){
                NuminsideR.add(i);
            }
        }
        return NuminsideR.size();
    }

    public double CalculateDistance(Double x1,Double y1, Double x2 ,Double y2){
        return Math.sqrt(Math.pow((x1-x2),2) + Math.pow((y1-y2),2));
    }

    public void exchange(){
        for (int i = 0 ; i < Pointx_input_initial.size();i++ ){
            Pointx_input.add(Pointx_input_initial.get(i) - FinalCenterX);
            Pointy_input.add(Pointy_input_initial.get(i) - FinalCenterY);
        }
    }

    public void DktoPolar() throws FileNotFoundException {
        java.io.File file4 = new java.io.File("C:\\Users\\87969\\Desktop\\test\\DktoPolarTest.txt");
        PrintWriter Result_OutPut = new PrintWriter(file4);
        for(int i = 0 ;i < Pointx_input.size();i++){
            double Theta = 0;
            Double R = Math.sqrt(Math.pow(Pointx_input.get(i),2) + Math.pow(Pointy_input.get(i),2));
            Theta = CalculateTheta(Pointx_input.get(i),Pointy_input.get(i),R);
            Result_OutPut.println("//////////////DktoPolarDktoPolarDktoPolar");
            Result_OutPut.println("DktoPolarTest:R " + R);
            Result_OutPut.println("DktoPolarTest:Theta" + Theta);
            Result_OutPut.println("DktoPolarTest:Pointx_input.get(i) " + Pointx_input.get(i));
            Result_OutPut.println("DktoPolarTest:Pointy_input.get(i) " + Pointy_input.get(i));
            Result_OutPut.println("/////////////DktoPolarDktoPolarDktoPolar");
            Row_input.add(R);
            Theta_input.add(Theta);
        }
        Result_OutPut.close();
    }

    public void LoopforCalculateArea() throws FileNotFoundException {
        ArrayList<Double> Row_input_forcal = new ArrayList<>(Row_input);
        ArrayList<Double> Theta_input_forcal = new ArrayList<>(Theta_input);
        ArrayList<Double> AngleArrangeList = new ArrayList<>();
        java.io.File file4 = new java.io.File("C:\\Users\\87969\\Desktop\\test\\meanshiftAreaSectorR.txt");
        PrintWriter Result_OutPu2 = new PrintWriter(file4);
        for(int i = 0 ; i < 2 * Math.PI / SplitTheta ;i++){
            AngleArrangeList.add(SplitTheta * i);
        }

        for (int i = 0 ; i < AngleArrangeList.size() ; i++){
            System.out.println("第 " + i + " 次外部循环");
            ArrayList<Double> Row_input_temp = new ArrayList<>();
            ArrayList<Double> Theta_input_temp = new ArrayList<>();
            for(int j = 0 ; j < Theta_input_forcal.size() ; j++){
                if((Theta_input_forcal.get(j) > AngleArrangeList.get(i)) && Theta_input_forcal.get(j) < (AngleArrangeList.get(i) + SplitTheta )){
                    System.out.println("第 " + i + " 次外部循环，第 " + j + " 次内部循环");
                    Row_input_temp.add(Row_input_forcal.get(j));
                    Theta_input_temp.add(Theta_input_forcal.get(j));
                }
            }
            int AllNumberofPointsinthisSector = Row_input_temp.size();
            double temp_radius = SplitRadiusWidth;
            ArrayList<Integer> insideRowNumber_history = new ArrayList<>();//在扇形内的点的编号
            ArrayList<Integer> insideRowNumberlength = new ArrayList<>();//记录上一个半径下，扇形区域内点的个数
            int insideRowNumberlength_history = 1;
            while (true){
                insideRowNumberlength.add(insideRowNumList(temp_radius,Row_input_temp).size());//
                int temp_size = insideRowNumberlength.size();
                if(((insideRowNumberlength.get(temp_size - 1) /insideRowNumberlength_history)  < IncreasingRate) && ((insideRowNumberlength.get(temp_size - 1)) < 0.8 * temp_size)){
                    break;
                }
                else {
                    System.out.println("111111111111111111111111111111111111111111111111111111111111111");
                    ArrayList<Integer> insideRowNumberList_temp = new ArrayList<>();
                    insideRowNumberList_temp = insideRowNumList(temp_radius,Row_input_temp);
                    ArrayList<Integer> insideRowNumber_history_temp = new ArrayList<>();//临时-在扇形内的点的编号
                    insideRowNumber_history = insideRowNumber_history_temp;
                    for (int ij = 0 ; ij < insideRowNumberList_temp.size();ij++){
                        insideRowNumber_history.add(insideRowNumberList_temp.get(ij));
                    }
                    temp_radius = temp_radius + SplitRadiusWidth;
                    insideRowNumberlength_history = insideRowNumberlength.get(temp_size - 1);
                }
            }
            ArrayList<Double> Result_Row_temp = new ArrayList<>();
            ArrayList<Double> Result_Theta_temp = new ArrayList<>();
            for(int ii = 0 ; ii < insideRowNumber_history.size() ; ii++){
                Result_Row_temp.add(Row_input_temp.get(insideRowNumber_history.get(ii)));
                Result_Theta_temp.add(Theta_input_temp.get(insideRowNumber_history.get(ii)));
            }
            DataType<Double> Row_data = new DataType<>(Result_Row_temp);
            DataType<Double> Theta_data = new DataType<>(Result_Theta_temp);
            Result_Row.add(Row_data);
            Result_Theta.add(Theta_data);
            Result_OutPu2.println(temp_radius);
            Area = Area + Math.PI * Math.pow(temp_radius,2) * (SplitTheta / (2 * Math.PI));
        }
        System.out.println("最终面积为： " + Area);
        Result_OutPu2.close();
        java.io.File file3 = new java.io.File("C:\\Users\\87969\\Desktop\\test\\meanshiftAreaRowandTheta.txt");
        PrintWriter Result_OutPut = new PrintWriter(file3);


        for(int iii = 0 ; iii < Result_Row.size();iii++){
            Result_OutPut.println("第" + iii + "个扇形的rowlist " + Result_Row.get(iii).Data);
            Result_OutPut.println("第" + iii + "个扇形的thetalist " + Result_Theta.get(iii).Data);
        }
        Result_OutPut.close();
    }

    public ArrayList<Integer> insideRowNumList(double Radius,ArrayList<Double>Row_input_temp){
        ArrayList<Integer> insideRowNumber = new ArrayList<>();
        for(int i = 0 ; i < Row_input_temp.size() ; i++){
            if( Row_input_temp.get(i) < Radius ){
                insideRowNumber.add(i);
            }
        }
        return insideRowNumber;
    }
}
