package index.gps;

//import test.entity.GpsCor;
import index.entity.Point;

public class GpsExchange {

    public Point gpsToPoints(Double lat,Double lon){

        Point point = new Point();

        double[] array = mct84Bl2xy(lat,lon);

        Double x = array[0];
        Double y = array[1];

        GpsConvertMethod gpsConvertMethod = new GpsConvertMethod("MCT2XY",lat,lon,55.5, 11789993,3128152);
        double[] array2 = gpsConvertMethod.coordinatexy;


        point.setColX(array2[0]);
        point.setColY(array2[1]);
//        point.setColX(x);
//        point.setColY(y);

        return point;


    }


//    public GpsCor pointsToGps(){
//
//        GpsCor gpsCor = new GpsCor();
//
//        return gpsCor;
//
//    }

    //墨卡托投影
    public  static double[] mct84Bl2xy(double lat, double lon) { //墨卡托投影转换平面坐标
        lon = lon * Math.PI / 180; //角度转弧度
        lat = lat * Math.PI / 180; //角度转弧度

        double B0 = 30 * Math.PI / 180; //角度转弧度

        double N = 0, e = 0, a = 0, b = 0, e2 = 0, K = 0;
        a = 6378137;
        b = 6356752.3142;
        e = Math.sqrt(1 - (b / a) * (b / a));//椭圆的第一偏心率，扁率
        e2 = Math.sqrt((a / b) * (a / b) - 1); //椭圆的第二偏心率, 扁率
        double CosB0 = Math.cos(B0);
        N = (a * a / b) / Math.sqrt(1 + e2 * e2 * CosB0 * CosB0);
        K = N * CosB0;

        double Pi = Math.PI;
        double SinB = Math.sin(lat);

        double tan = Math.tan(Pi / 4 + lat / 2);//墨卡托投影的计算中间值
        double E2 = Math.pow((1 - e * SinB) / (1 + e * SinB), e / 2);
        double xx = tan * E2;

        double xc = K * Math.log(xx);
        double yc = K * lon;

        double[] result = new double[2];
        result[0] = (int) xc;
        result[1] = (int) yc;
        return result;
    }


}
